#!/bin/bash
GROUP=$1
if [ -z "$GROUP" ] ; then
 echo Use: $0 GROUPNAME [QUOTA]
 exit 1
fi
QUOTA=$2

. `dirname $0`/config
set -e
echo Adding $GROUPZFS/$GROUP with ${QUOTA:-100GB} quota
zfs create -o quota=${QUOTA:-100GB} $GROUPZFS/$GROUP
zfs create $GROUPZFS/$GROUP/config
zfs create $GROUPZFS/$GROUP/general
zfs create $GROUPZFS/$GROUP/general/people
zfs create $GROUPZFS/$GROUP/general/shares

mkdir /$GROUPZFS/$GROUP/config/logs
mkdir /$GROUPZFS/$GROUP/config/samba
mkdir /$GROUPZFS/$GROUP/config/samba/shares
mkdir /$GROUPZFS/$GROUP/config/samba/logs

# Create the samba configs
IP=`getent hosts ${GROUP}-fs | awk ' { print $1 } '`
if [ ! -z $IP ] ; then
 cat <<EOF >/$GROUPZFS/$GROUP/config/samba/ipaddress
# Autogenerated by $0 at `date`
# Bind to particular IP address
    interfaces = $IP/24
    bind interfaces only = yes
EOF
 echo Created config/samba/ipaddress
else
 echo No IP address for ${GROUP}-fs, create config/samba/ipaddress manually
fi

# Link that samba config to an IP address in data/config/samba/servers
if [ -L /$CONFIGZFS/ips/$IP ] ; then
 echo /$CONFIGZFS/ips/$IP already linked
else
 ln -s /$CONFIGZFS/samba/servers/$IP /$CONFIGZFS/ips/$IP
 echo Symlinked /$CONFIGZFS/samba/servers/$IP to /$CONFIGZFS/ips/$IP
fi

# Link that 
if [ -L /$CONFIGZFS/samba/servers/$IP ] ; then
 echo /$CONFIGZFS/samba/servers/$IP is already a symlink
else
 ln -s /$GROUPZFS/${GROUP}/config/samba/smb.conf /$CONFIGZFS/samba/servers/$IP
 echo Symlinked /$GROUPZFS/${GROUP}/config/samba/smb.conf to /$CONFIGZFS/samba/servers/$IP
fi

# Link some log directories
if [ -L /$CONFIGZFS/log/samba/$IP ] ; then
 echo /$CONFIGZFS/log/samba/$IP is already a symlink
else
 ln -s /$GROUPZFS/${GROUP}/config/logs/samba /$CONFIGZFS/log/samba/$IP
 echo Symlinked /$GROUPZFS/${GROUP}/config/logs/samba to /$CONFIGZFS/log/samba/$IP
fi

if [ ! -f /$GROUPZFS/$GROUP/config/samba/smb.conf ] ; then
cat <<EOF >/$GROUPZFS/$GROUP/config/samba/smb.conf
# Samba config autogenerated by $0 at `date`
[global]
# Sets the netbios name to the dns name of this server (required)
include= /etc/samba/netbiosname.conf
# Sets an accepted alias to the service name
netbios aliases = ${GROUP}-fs
server string = ${GROUP}-fs server
# Bind to a specific interface:
include = /${GROUPZFS}/${GROUP}/config/samba/ipaddress
# Our common configurations 
include = /${CONFIGZFS}/samba/common/noprint
include = /${CONFIGZFS}/samba/common/adbind
include = /${CONFIGZFS}/samba/common/auth
include = /${CONFIGZFS}/samba/common/general
include = /${CONFIGZFS}/samba/common/nounixext
# Shares are included from the runtime-generated file
include = /${GROUPZFS}/${GROUP}/config/samba/.sharelist
# End smb.conf
EOF
echo Createed config/samba/smb.conf
else
 echo config/samba/smb.conf already exists
fi

if [ ! -f /$GROUPZFS/$GROUP/config/samba/shares/hobbit ] ; then
# Add the hobbit share
cat <<EOF >/$GROUPZFS/$GROUP/config/samba/shares/hobbit
[hobbit]
   include = /${CONFIGZFS}/samba/common/hobbitshare
   path = /${GROUPZFS}/${GROUP}/.hobbit
EOF
 echo Hobbit share config created
else
 echo Hobbit share already configured
fi

mkdir -p /${GROUPZFS}/${GROUP}/.hobbit
if [ ! -f /${GROUPZFS}/${GROUP}/.hobbit/hobbit.txt ] ; then
 echo hobbit >/${GROUPZFS}/${GROUP}/.hobbit/hobbit.txt
 echo Created file for hobbit share
else
 echo File for hobbit share already exists
fi
